
(in-package #:taxonomy)

(defparameter *projects* (make-hash-table :test #'equalp))

(defmacro defdeffer (name keylist store)
  (let ((realkeys (mapcar 
		   #'(lambda (x)
		       (intern (format nil "~A" x)
			       "KEYWORD"))
		   keylist)))
    `(defun ,name (&key ,@keylist)
       (setf (gethash ,(car keylist) ,store)
	     (list ,@(mapcar #'(lambda (x y)
				 `(cons ,x ,y))
			     realkeys
			     keylist))))))

(defdeffer def-project (label name category description) *projects*)

(defun classify ()
  (let ((cats (make-hash-table :test #'equalp))
	catl)

    (maphash #'(lambda (k x)
		 (pushnew k
			  (gethash (cdr (assoc :category x)) cats)))
	     *projects*)

    (maphash #'(lambda (k x)
		 (push (list k x) catl))
	     cats)
    (mapcar #'(lambda (x)
		(setf (cadr x)
		      (mapcar #'(lambda (x)
				  (gethash x *projects*))
			      (sort (cadr x) #'string-lessp)))
		x)
	    (sort catl #'string-lessp :key #'car))))

(defun render-html-taxonomy (fname)
  (with-open-file (strm fname
			:direction :output
			:if-exists :supersede)

    (format strm "<html><body>~%<ul>")

    (let ((dbase (classify)))
      (dolist (cat dbase)
	(format strm "<li>~A~%   <table width=\"80%\">~%" (car cat))
	(dolist (proj (cadr cat))
	  (format strm
"      <tr>
         <td valign=\"top\" width=\"30%\">
            <a href=\"http://common-lisp.net/project/~A\">~A</a>
         </td>
         <td>~A</td>
       </tr>~%~%"
       (cdr (assoc :label proj)) ;; Like in the old days :)
       (cdr (assoc :name proj))
       (cdr (assoc :description proj))))
	(format strm "   </table>~%</li>~%~%")))

    (format strm "</body></html>~%")))
